/**
 * <copyright>
 * </copyright>
 *
 * $Id: ComboImpl.java 9614 2012-06-05 05:37:25Z hoenninger $
 */
package org.openxma.dsl.pom.model.impl;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.InternalEList;
import org.openxma.dsl.core.model.Constraint;
import org.openxma.dsl.core.model.DataTypeAndTypeParameter;
import org.openxma.dsl.core.model.ReferenceableByXmadslVariable;
import org.openxma.dsl.core.model.ValidatorReference;
import org.openxma.dsl.core.model.impl.ReferenceableByXmadslVariableImpl;
import org.openxma.dsl.pom.PomPackage;
import org.openxma.dsl.pom.model.Combo;
import org.openxma.dsl.pom.model.ComposedElement;
import org.openxma.dsl.pom.model.DataBindingElement;
import org.openxma.dsl.pom.model.FieldFlag;
import org.openxma.dsl.pom.model.GuiElement;
import org.openxma.dsl.pom.model.IElementOnWhichCanBeAttached;
import org.openxma.dsl.pom.model.IElementWithLayoutData;
import org.openxma.dsl.pom.model.IReferenceableByStatementVariable;
import org.openxma.dsl.pom.model.LayoutDataProperty;
import org.openxma.dsl.pom.model.SimpleElement;
import org.openxma.dsl.pom.model.StrictFlag;
import org.openxma.dsl.pom.model.TabableFlag;
import org.openxma.dsl.pom.model.TextProperty;


/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Combo</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link org.openxma.dsl.pom.model.impl.ComboImpl#getLayoutProperties <em>Layout Properties</em>}</li>
 *   <li>{@link org.openxma.dsl.pom.model.impl.ComboImpl#getFieldFlags <em>Field Flags</em>}</li>
 *   <li>{@link org.openxma.dsl.pom.model.impl.ComboImpl#getTabableFlag <em>Tabable Flag</em>}</li>
 *   <li>{@link org.openxma.dsl.pom.model.impl.ComboImpl#getName <em>Name</em>}</li>
 *   <li>{@link org.openxma.dsl.pom.model.impl.ComboImpl#getConstraints <em>Constraints</em>}</li>
 *   <li>{@link org.openxma.dsl.pom.model.impl.ComboImpl#getFormat <em>Format</em>}</li>
 *   <li>{@link org.openxma.dsl.pom.model.impl.ComboImpl#getType <em>Type</em>}</li>
 *   <li>{@link org.openxma.dsl.pom.model.impl.ComboImpl#getStrictFlag <em>Strict Flag</em>}</li>
 *   <li>{@link org.openxma.dsl.pom.model.impl.ComboImpl#getTextProperties <em>Text Properties</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class ComboImpl extends IGuiElementWithEventImpl implements Combo {
	/**
	 * The cached value of the '{@link #getLayoutProperties() <em>Layout Properties</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getLayoutProperties()
	 * @generated
	 * @ordered
	 */
	protected EList<LayoutDataProperty> layoutProperties;

	/**
	 * The cached value of the '{@link #getFieldFlags() <em>Field Flags</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getFieldFlags()
	 * @generated
	 * @ordered
	 */
	protected EList<FieldFlag> fieldFlags;

	/**
	 * The cached value of the '{@link #getTabableFlag() <em>Tabable Flag</em>}' containment reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see #getTabableFlag()
	 * @generated
	 * @ordered
	 */
    protected TabableFlag tabableFlag;

	/**
	 * The default value of the '{@link #getName() <em>Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getName()
	 * @generated
	 * @ordered
	 */
	protected static final String NAME_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getName() <em>Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getName()
	 * @generated
	 * @ordered
	 */
	protected String name = NAME_EDEFAULT;

	/**
	 * The cached value of the '{@link #getConstraints() <em>Constraints</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getConstraints()
	 * @generated
	 * @ordered
	 */
	protected EList<Constraint> constraints;

	/**
	 * The cached value of the '{@link #getFormat() <em>Format</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getFormat()
	 * @generated
	 * @ordered
	 */
	protected ValidatorReference format;

	/**
	 * The cached value of the '{@link #getType() <em>Type</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getType()
	 * @generated
	 * @ordered
	 */
	protected DataTypeAndTypeParameter type;

	/**
	 * The cached value of the '{@link #getStrictFlag() <em>Strict Flag</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getStrictFlag()
	 * @generated
	 * @ordered
	 */
	protected StrictFlag strictFlag;

	/**
	 * The cached value of the '{@link #getTextProperties() <em>Text Properties</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getTextProperties()
	 * @generated
	 * @ordered
	 */
	protected EList<TextProperty> textProperties;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ComboImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return PomPackage.Literals.COMBO;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<LayoutDataProperty> getLayoutProperties() {
		if (layoutProperties == null) {
			layoutProperties = new EObjectContainmentEList<LayoutDataProperty>(LayoutDataProperty.class, this, PomPackage.COMBO__LAYOUT_PROPERTIES);
		}
		return layoutProperties;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<FieldFlag> getFieldFlags() {
		if (fieldFlags == null) {
			fieldFlags = new EObjectContainmentEList<FieldFlag>(FieldFlag.class, this, PomPackage.COMBO__FIELD_FLAGS);
		}
		return fieldFlags;
	}

	/**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public TabableFlag getTabableFlag() {
		return tabableFlag;
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public NotificationChain basicSetTabableFlag(TabableFlag newTabableFlag, NotificationChain msgs) {
		TabableFlag oldTabableFlag = tabableFlag;
		tabableFlag = newTabableFlag;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, PomPackage.COMBO__TABABLE_FLAG, oldTabableFlag, newTabableFlag);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public void setTabableFlag(TabableFlag newTabableFlag) {
		if (newTabableFlag != tabableFlag) {
			NotificationChain msgs = null;
			if (tabableFlag != null)
				msgs = ((InternalEObject)tabableFlag).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - PomPackage.COMBO__TABABLE_FLAG, null, msgs);
			if (newTabableFlag != null)
				msgs = ((InternalEObject)newTabableFlag).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - PomPackage.COMBO__TABABLE_FLAG, null, msgs);
			msgs = basicSetTabableFlag(newTabableFlag, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, PomPackage.COMBO__TABABLE_FLAG, newTabableFlag, newTabableFlag));
	}

    /**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getName() {
		return name;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setName(String newName) {
		String oldName = name;
		name = newName;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, PomPackage.COMBO__NAME, oldName, name));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<Constraint> getConstraints() {
		if (constraints == null) {
			constraints = new EObjectContainmentEList<Constraint>(Constraint.class, this, PomPackage.COMBO__CONSTRAINTS);
		}
		return constraints;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ValidatorReference getFormat() {
		return format;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetFormat(ValidatorReference newFormat, NotificationChain msgs) {
		ValidatorReference oldFormat = format;
		format = newFormat;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, PomPackage.COMBO__FORMAT, oldFormat, newFormat);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setFormat(ValidatorReference newFormat) {
		if (newFormat != format) {
			NotificationChain msgs = null;
			if (format != null)
				msgs = ((InternalEObject)format).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - PomPackage.COMBO__FORMAT, null, msgs);
			if (newFormat != null)
				msgs = ((InternalEObject)newFormat).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - PomPackage.COMBO__FORMAT, null, msgs);
			msgs = basicSetFormat(newFormat, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, PomPackage.COMBO__FORMAT, newFormat, newFormat));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public DataTypeAndTypeParameter getType() {
		return type;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetType(DataTypeAndTypeParameter newType, NotificationChain msgs) {
		DataTypeAndTypeParameter oldType = type;
		type = newType;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, PomPackage.COMBO__TYPE, oldType, newType);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setType(DataTypeAndTypeParameter newType) {
		if (newType != type) {
			NotificationChain msgs = null;
			if (type != null)
				msgs = ((InternalEObject)type).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - PomPackage.COMBO__TYPE, null, msgs);
			if (newType != null)
				msgs = ((InternalEObject)newType).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - PomPackage.COMBO__TYPE, null, msgs);
			msgs = basicSetType(newType, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, PomPackage.COMBO__TYPE, newType, newType));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public StrictFlag getStrictFlag() {
		return strictFlag;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetStrictFlag(StrictFlag newStrictFlag, NotificationChain msgs) {
		StrictFlag oldStrictFlag = strictFlag;
		strictFlag = newStrictFlag;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, PomPackage.COMBO__STRICT_FLAG, oldStrictFlag, newStrictFlag);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setStrictFlag(StrictFlag newStrictFlag) {
		if (newStrictFlag != strictFlag) {
			NotificationChain msgs = null;
			if (strictFlag != null)
				msgs = ((InternalEObject)strictFlag).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - PomPackage.COMBO__STRICT_FLAG, null, msgs);
			if (newStrictFlag != null)
				msgs = ((InternalEObject)newStrictFlag).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - PomPackage.COMBO__STRICT_FLAG, null, msgs);
			msgs = basicSetStrictFlag(newStrictFlag, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, PomPackage.COMBO__STRICT_FLAG, newStrictFlag, newStrictFlag));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<TextProperty> getTextProperties() {
		if (textProperties == null) {
			textProperties = new EObjectContainmentEList<TextProperty>(TextProperty.class, this, PomPackage.COMBO__TEXT_PROPERTIES);
		}
		return textProperties;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case PomPackage.COMBO__LAYOUT_PROPERTIES:
				return ((InternalEList<?>)getLayoutProperties()).basicRemove(otherEnd, msgs);
			case PomPackage.COMBO__FIELD_FLAGS:
				return ((InternalEList<?>)getFieldFlags()).basicRemove(otherEnd, msgs);
			case PomPackage.COMBO__TABABLE_FLAG:
				return basicSetTabableFlag(null, msgs);
			case PomPackage.COMBO__CONSTRAINTS:
				return ((InternalEList<?>)getConstraints()).basicRemove(otherEnd, msgs);
			case PomPackage.COMBO__FORMAT:
				return basicSetFormat(null, msgs);
			case PomPackage.COMBO__TYPE:
				return basicSetType(null, msgs);
			case PomPackage.COMBO__STRICT_FLAG:
				return basicSetStrictFlag(null, msgs);
			case PomPackage.COMBO__TEXT_PROPERTIES:
				return ((InternalEList<?>)getTextProperties()).basicRemove(otherEnd, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case PomPackage.COMBO__LAYOUT_PROPERTIES:
				return getLayoutProperties();
			case PomPackage.COMBO__FIELD_FLAGS:
				return getFieldFlags();
			case PomPackage.COMBO__TABABLE_FLAG:
				return getTabableFlag();
			case PomPackage.COMBO__NAME:
				return getName();
			case PomPackage.COMBO__CONSTRAINTS:
				return getConstraints();
			case PomPackage.COMBO__FORMAT:
				return getFormat();
			case PomPackage.COMBO__TYPE:
				return getType();
			case PomPackage.COMBO__STRICT_FLAG:
				return getStrictFlag();
			case PomPackage.COMBO__TEXT_PROPERTIES:
				return getTextProperties();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case PomPackage.COMBO__LAYOUT_PROPERTIES:
				getLayoutProperties().clear();
				getLayoutProperties().addAll((Collection<? extends LayoutDataProperty>)newValue);
				return;
			case PomPackage.COMBO__FIELD_FLAGS:
				getFieldFlags().clear();
				getFieldFlags().addAll((Collection<? extends FieldFlag>)newValue);
				return;
			case PomPackage.COMBO__TABABLE_FLAG:
				setTabableFlag((TabableFlag)newValue);
				return;
			case PomPackage.COMBO__NAME:
				setName((String)newValue);
				return;
			case PomPackage.COMBO__CONSTRAINTS:
				getConstraints().clear();
				getConstraints().addAll((Collection<? extends Constraint>)newValue);
				return;
			case PomPackage.COMBO__FORMAT:
				setFormat((ValidatorReference)newValue);
				return;
			case PomPackage.COMBO__TYPE:
				setType((DataTypeAndTypeParameter)newValue);
				return;
			case PomPackage.COMBO__STRICT_FLAG:
				setStrictFlag((StrictFlag)newValue);
				return;
			case PomPackage.COMBO__TEXT_PROPERTIES:
				getTextProperties().clear();
				getTextProperties().addAll((Collection<? extends TextProperty>)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case PomPackage.COMBO__LAYOUT_PROPERTIES:
				getLayoutProperties().clear();
				return;
			case PomPackage.COMBO__FIELD_FLAGS:
				getFieldFlags().clear();
				return;
			case PomPackage.COMBO__TABABLE_FLAG:
				setTabableFlag((TabableFlag)null);
				return;
			case PomPackage.COMBO__NAME:
				setName(NAME_EDEFAULT);
				return;
			case PomPackage.COMBO__CONSTRAINTS:
				getConstraints().clear();
				return;
			case PomPackage.COMBO__FORMAT:
				setFormat((ValidatorReference)null);
				return;
			case PomPackage.COMBO__TYPE:
				setType((DataTypeAndTypeParameter)null);
				return;
			case PomPackage.COMBO__STRICT_FLAG:
				setStrictFlag((StrictFlag)null);
				return;
			case PomPackage.COMBO__TEXT_PROPERTIES:
				getTextProperties().clear();
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case PomPackage.COMBO__LAYOUT_PROPERTIES:
				return layoutProperties != null && !layoutProperties.isEmpty();
			case PomPackage.COMBO__FIELD_FLAGS:
				return fieldFlags != null && !fieldFlags.isEmpty();
			case PomPackage.COMBO__TABABLE_FLAG:
				return tabableFlag != null;
			case PomPackage.COMBO__NAME:
				return NAME_EDEFAULT == null ? name != null : !NAME_EDEFAULT.equals(name);
			case PomPackage.COMBO__CONSTRAINTS:
				return constraints != null && !constraints.isEmpty();
			case PomPackage.COMBO__FORMAT:
				return format != null;
			case PomPackage.COMBO__TYPE:
				return type != null;
			case PomPackage.COMBO__STRICT_FLAG:
				return strictFlag != null;
			case PomPackage.COMBO__TEXT_PROPERTIES:
				return textProperties != null && !textProperties.isEmpty();
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public int eBaseStructuralFeatureID(int derivedFeatureID, Class<?> baseClass) {
		if (baseClass == ReferenceableByXmadslVariable.class) {
			switch (derivedFeatureID) {
				default: return -1;
			}
		}
		if (baseClass == DataBindingElement.class) {
			switch (derivedFeatureID) {
				default: return -1;
			}
		}
		if (baseClass == IElementWithLayoutData.class) {
			switch (derivedFeatureID) {
				case PomPackage.COMBO__LAYOUT_PROPERTIES: return PomPackage.IELEMENT_WITH_LAYOUT_DATA__LAYOUT_PROPERTIES;
				case PomPackage.COMBO__FIELD_FLAGS: return PomPackage.IELEMENT_WITH_LAYOUT_DATA__FIELD_FLAGS;
				case PomPackage.COMBO__TABABLE_FLAG: return PomPackage.IELEMENT_WITH_LAYOUT_DATA__TABABLE_FLAG;
				default: return -1;
			}
		}
		if (baseClass == GuiElement.class) {
			switch (derivedFeatureID) {
				default: return -1;
			}
		}
		if (baseClass == IElementOnWhichCanBeAttached.class) {
			switch (derivedFeatureID) {
				default: return -1;
			}
		}
		if (baseClass == ComposedElement.class) {
			switch (derivedFeatureID) {
				default: return -1;
			}
		}
		if (baseClass == SimpleElement.class) {
			switch (derivedFeatureID) {
				default: return -1;
			}
		}
		if (baseClass == IReferenceableByStatementVariable.class) {
			switch (derivedFeatureID) {
				default: return -1;
			}
		}
		return super.eBaseStructuralFeatureID(derivedFeatureID, baseClass);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public int eDerivedStructuralFeatureID(int baseFeatureID, Class<?> baseClass) {
		if (baseClass == ReferenceableByXmadslVariable.class) {
			switch (baseFeatureID) {
				default: return -1;
			}
		}
		if (baseClass == DataBindingElement.class) {
			switch (baseFeatureID) {
				default: return -1;
			}
		}
		if (baseClass == IElementWithLayoutData.class) {
			switch (baseFeatureID) {
				case PomPackage.IELEMENT_WITH_LAYOUT_DATA__LAYOUT_PROPERTIES: return PomPackage.COMBO__LAYOUT_PROPERTIES;
				case PomPackage.IELEMENT_WITH_LAYOUT_DATA__FIELD_FLAGS: return PomPackage.COMBO__FIELD_FLAGS;
				case PomPackage.IELEMENT_WITH_LAYOUT_DATA__TABABLE_FLAG: return PomPackage.COMBO__TABABLE_FLAG;
				default: return -1;
			}
		}
		if (baseClass == GuiElement.class) {
			switch (baseFeatureID) {
				default: return -1;
			}
		}
		if (baseClass == IElementOnWhichCanBeAttached.class) {
			switch (baseFeatureID) {
				default: return -1;
			}
		}
		if (baseClass == ComposedElement.class) {
			switch (baseFeatureID) {
				default: return -1;
			}
		}
		if (baseClass == SimpleElement.class) {
			switch (baseFeatureID) {
				default: return -1;
			}
		}
		if (baseClass == IReferenceableByStatementVariable.class) {
			switch (baseFeatureID) {
				default: return -1;
			}
		}
		return super.eDerivedStructuralFeatureID(baseFeatureID, baseClass);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (name: ");
		result.append(name);
		result.append(')');
		return result.toString();
	}

} //ComboImpl
